import _extends from "babel-runtime/helpers/extends";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import _possibleConstructorReturn from "babel-runtime/helpers/possibleConstructorReturn";
import _inherits from "babel-runtime/helpers/inherits";
var __rest = this && this.__rest || function (s, e) {
    var t = {};
    for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
        if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
    }return t;
};
import React, { PureComponent } from "react";
import { Dropdown, Icon } from "antd";
// import { DropDownProps } from "antd/es/dropdown/dropdown";
import RMenu from "./../r-menu/r-menu";
var getMenus = function getMenus(props) {
    var validMenuItems = props.dataSource.filter(function (_ref) {
        var key = _ref.key;
        return key !== props.value;
    });
    return React.createElement(RMenu, { dataSource: validMenuItems });
};
var renderSelectedMenuItem = function renderSelectedMenuItem(props) {
    var current = props.dataSource.find(function (_ref2) {
        var key = _ref2.key;
        return key === props.value;
    });
    if (!current) {
        return "";
    }
    return current.children;
};

var RDropdownSelect = function (_PureComponent) {
    _inherits(RDropdownSelect, _PureComponent);

    function RDropdownSelect() {
        _classCallCheck(this, RDropdownSelect);

        return _possibleConstructorReturn(this, (RDropdownSelect.__proto__ || Object.getPrototypeOf(RDropdownSelect)).apply(this, arguments));
    }

    _createClass(RDropdownSelect, [{
        key: "render",
        value: function render() {
            var _a = this.props,
                iconType = _a.iconType,
                dropdownProps = _a.dropdownProps,
                rest = __rest(_a, ["iconType", "dropdownProps"]);
            return React.createElement(
                Dropdown,
                _extends({ overlay: getMenus(rest) }, dropdownProps),
                React.createElement(
                    "a",
                    null,
                    renderSelectedMenuItem(rest),
                    " ",
                    React.createElement(Icon, { type: iconType })
                )
            );
        }
    }]);

    return RDropdownSelect;
}(PureComponent);

export default RDropdownSelect;

RDropdownSelect.defaultProps = {
    dataSource: [],
    iconType: "caret-down"
};