import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import _possibleConstructorReturn from "babel-runtime/helpers/possibleConstructorReturn";
import _inherits from "babel-runtime/helpers/inherits";
var __rest = this && this.__rest || function (s, e) {
    var t = {};
    for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
        if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
    }return t;
};
import React, { Component } from "react";
import { Menu } from "antd";
export var RMenu = function (_Component) {
    _inherits(RMenu, _Component);

    function RMenu() {
        _classCallCheck(this, RMenu);

        var _this = _possibleConstructorReturn(this, (RMenu.__proto__ || Object.getPrototypeOf(RMenu)).apply(this, arguments));

        _this.renderMenuItem = function (_a) {
            var children = _a.children,
                rest = __rest(_a, ["children"]);
            return React.createElement(
                Menu.Item,
                rest,
                children
            );
        };
        _this.renderSubMenu = function (_a) {
            var children = _a.children,
                rest = __rest(_a, ["children"]);
            return React.createElement(
                Menu.SubMenu,
                rest,
                _this.renderSubMenus(children)
            );
        };
        _this.renderItemGroup = function (_a) {
            var children = _a.children,
                rest = __rest(_a, ["children"]);
            return React.createElement(
                Menu.ItemGroup,
                rest,
                children.map(_this.renderMenuItem)
            );
        };
        _this.renderSubMenus = function (subMenus) {
            return subMenus.map(function (_a) {
                var _a$type = _a.type,
                    type = _a$type === undefined ? "menuitem" : _a$type,
                    rest = __rest(_a, ["type"]);

                switch (type) {
                    case "menuitem":
                        return _this.renderMenuItem(rest);
                    case "submenu":
                        return _this.renderSubMenu(rest);
                    case "itemgroup":
                        return _this.renderItemGroup(rest);
                }
                // if (type === "menuitem") return this.renderMenuItem(rest as RMenuItem);
                // else if (type === "submenu") return this.renderSubMenu(rest as RSubMenu);
                // else if (type === "itemgroup") return this.renderItemGroup(rest as RItemGroup);
            });
        };
        _this.renderMenus = function (dataSource) {
            var renderMenu = function renderMenu(_a) {
                var _a$type2 = _a.type,
                    type = _a$type2 === undefined ? "menuitem" : _a$type2,
                    rest = __rest(_a, ["type"]);

                if (type === "menuitem") return _this.renderMenuItem(rest);
                return _this.renderSubMenu(rest);
            };
            return dataSource.map(renderMenu);
        };
        return _this;
    }

    _createClass(RMenu, [{
        key: "render",
        value: function render() {
            var _a = this.props,
                dataSource = _a.dataSource,
                rest = __rest(_a, ["dataSource"]);
            return React.createElement(
                Menu,
                rest,
                this.renderMenus(dataSource)
            );
        }
    }]);

    return RMenu;
}(Component);
export default RMenu;