"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RMenu = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _antd = require("antd");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var __rest = undefined && undefined.__rest || function (s, e) {
    var t = {};
    for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
        if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
    }return t;
};

var RMenu = exports.RMenu = function (_Component) {
    (0, _inherits3["default"])(RMenu, _Component);

    function RMenu() {
        (0, _classCallCheck3["default"])(this, RMenu);

        var _this = (0, _possibleConstructorReturn3["default"])(this, (RMenu.__proto__ || Object.getPrototypeOf(RMenu)).apply(this, arguments));

        _this.renderMenuItem = function (_a) {
            var children = _a.children,
                rest = __rest(_a, ["children"]);
            return _react2["default"].createElement(
                _antd.Menu.Item,
                rest,
                children
            );
        };
        _this.renderSubMenu = function (_a) {
            var children = _a.children,
                rest = __rest(_a, ["children"]);
            return _react2["default"].createElement(
                _antd.Menu.SubMenu,
                rest,
                _this.renderSubMenus(children)
            );
        };
        _this.renderItemGroup = function (_a) {
            var children = _a.children,
                rest = __rest(_a, ["children"]);
            return _react2["default"].createElement(
                _antd.Menu.ItemGroup,
                rest,
                children.map(_this.renderMenuItem)
            );
        };
        _this.renderSubMenus = function (subMenus) {
            return subMenus.map(function (_a) {
                var _a$type = _a.type,
                    type = _a$type === undefined ? "menuitem" : _a$type,
                    rest = __rest(_a, ["type"]);

                switch (type) {
                    case "menuitem":
                        return _this.renderMenuItem(rest);
                    case "submenu":
                        return _this.renderSubMenu(rest);
                    case "itemgroup":
                        return _this.renderItemGroup(rest);
                }
                // if (type === "menuitem") return this.renderMenuItem(rest as RMenuItem);
                // else if (type === "submenu") return this.renderSubMenu(rest as RSubMenu);
                // else if (type === "itemgroup") return this.renderItemGroup(rest as RItemGroup);
            });
        };
        _this.renderMenus = function (dataSource) {
            var renderMenu = function renderMenu(_a) {
                var _a$type2 = _a.type,
                    type = _a$type2 === undefined ? "menuitem" : _a$type2,
                    rest = __rest(_a, ["type"]);

                if (type === "menuitem") return _this.renderMenuItem(rest);
                return _this.renderSubMenu(rest);
            };
            return dataSource.map(renderMenu);
        };
        return _this;
    }

    (0, _createClass3["default"])(RMenu, [{
        key: "render",
        value: function render() {
            var _a = this.props,
                dataSource = _a.dataSource,
                rest = __rest(_a, ["dataSource"]);
            return _react2["default"].createElement(
                _antd.Menu,
                rest,
                this.renderMenus(dataSource)
            );
        }
    }]);
    return RMenu;
}(_react.Component);

exports["default"] = RMenu;