/// <reference types="react" />
import { Component, ReactNode } from "react";
import { SelectProps, OptionProps } from "antd/lib/select";
export interface ROptionProps extends OptionProps {
    key?: string;
    title?: string;
    label: ReactNode;
}
export interface RSelectProps extends SelectProps {
    dataSource: ROptionProps[];
}
export declare class RSelect extends Component<RSelectProps> {
    renderOption: ({key, value, label, ...rest}: ROptionProps) => JSX.Element;
    render(): JSX.Element;
}
export default RSelect;
