/// <reference types="react" />
import React, { PureComponent } from "react";
import { RMenuChild } from "./../r-menu/r-menu";
export interface DropdownPropsWithoutOverlay {
    trigger?: Array<"click" | "hover">;
    style?: React.CSSProperties;
    onVisibleChange?: (visible?: boolean) => void;
    visible?: boolean;
    disabled?: boolean;
    align?: Object;
    getPopupContainer?: (triggerNode: Element) => HTMLElement;
    prefixCls?: string;
    className?: string;
    placement?: "topLeft" | "topCenter" | "topRight" | "bottomLeft" | "bottomCenter" | "bottomRight";
}
export interface RDropdownSelectProps {
    dataSource: RMenuChild[];
    value: string;
    iconType?: string;
    dropdownProps?: DropdownPropsWithoutOverlay;
}
export default class RDropdownSelect extends PureComponent<RDropdownSelectProps> {
    static defaultProps: Partial<RDropdownSelectProps>;
    render(): JSX.Element;
}
