"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _antd = require("antd");

var _rMenu = require("./../r-menu/r-menu");

var _rMenu2 = _interopRequireDefault(_rMenu);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var __rest = undefined && undefined.__rest || function (s, e) {
    var t = {};
    for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
        if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
    }return t;
};
// import { DropDownProps } from "antd/es/dropdown/dropdown";

var getMenus = function getMenus(props) {
    var validMenuItems = props.dataSource.filter(function (_ref) {
        var key = _ref.key;
        return key !== props.value;
    });
    return _react2["default"].createElement(_rMenu2["default"], { dataSource: validMenuItems });
};
var renderSelectedMenuItem = function renderSelectedMenuItem(props) {
    var current = props.dataSource.find(function (_ref2) {
        var key = _ref2.key;
        return key === props.value;
    });
    if (!current) {
        return "";
    }
    return current.children;
};

var RDropdownSelect = function (_PureComponent) {
    (0, _inherits3["default"])(RDropdownSelect, _PureComponent);

    function RDropdownSelect() {
        (0, _classCallCheck3["default"])(this, RDropdownSelect);
        return (0, _possibleConstructorReturn3["default"])(this, (RDropdownSelect.__proto__ || Object.getPrototypeOf(RDropdownSelect)).apply(this, arguments));
    }

    (0, _createClass3["default"])(RDropdownSelect, [{
        key: "render",
        value: function render() {
            var _a = this.props,
                iconType = _a.iconType,
                dropdownProps = _a.dropdownProps,
                rest = __rest(_a, ["iconType", "dropdownProps"]);
            return _react2["default"].createElement(
                _antd.Dropdown,
                (0, _extends3["default"])({ overlay: getMenus(rest) }, dropdownProps),
                _react2["default"].createElement(
                    "a",
                    null,
                    renderSelectedMenuItem(rest),
                    " ",
                    _react2["default"].createElement(_antd.Icon, { type: iconType })
                )
            );
        }
    }]);
    return RDropdownSelect;
}(_react.PureComponent);

exports["default"] = RDropdownSelect;

RDropdownSelect.defaultProps = {
    dataSource: [],
    iconType: "caret-down"
};
module.exports = exports["default"];